
/*
xpvox copyright (c) 2005 Jan Panteltje

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "forms.h"
#include <stdlib.h>
#include "xpvox.h"


//void one_second_tick(int sig);


FD_xpvox *fdui;
char *mydata;

FD_xpvox *create_form_xpvox(void)
{
FL_OBJECT *obj;
fdui = (FD_xpvox *) fl_calloc(1, sizeof(*fdui));

fl_set_idle_callback(idle_cb, 0);

fdui -> xpvox = fl_bgn_form(FL_NO_BOX, 400, 300);

obj = fl_add_box(FL_UP_BOX, 0, 0, 400, 300,"");

fdui -> main_form_text = obj =\
	fl_add_text(FL_NORMAL_TEXT, 100, 5, 200, 20, "Panteltje (c) xpvox");
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);

fdui->beacon_sound_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 110, 30, 50, 25, "BEACON");
	fl_set_object_color(obj, FL_COL1, FL_RED);
	fl_set_object_callback(obj, beacon_sound_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui -> beacon_period_time_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 170, 30, 50, 25, "sec");
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, beacon_period_time_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
//	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
//	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_input_maxchars(obj, 5);

fdui->timed_play_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 110, 65, 50, 25, "");
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);
	fl_set_object_callback(obj, timed_play_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui -> off_time_x10_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 95, 95, 25, 15, "x10");
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);
	fl_set_object_callback(obj, off_time_x10_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui -> timed_play_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 170, 65, 50, 25, "start\nhh:mm");
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, timed_play_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
//	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
//	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_input_maxchars(obj, 5);

fdui -> play_one_per_day_next_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 265, 30, 30, 25, "");
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM);
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, play_one_per_day_next_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
//	fl_set_object_lsize(obj, FL_TINY_SIZE);
	fl_set_input_maxchars(obj, 2);

fdui -> play_one_per_day_next_text = obj =\
	fl_add_text(FL_NORMAL_TEXT, 265, 55, 40, 10, "next");
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui->play_one_per_day_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 265, 65, 30, 25, "daily");
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_callback(obj, play_one_per_day_button_cb, 0);

fdui -> agc_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 265, 100, 30, 25, "AGC");
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);
	fl_set_object_callback(obj, agc_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
//fl_hide_object(obj); /* agc has no effect unless output stream via for example sox to an _other_soundcard, use xpequ! */
 
               
fdui->transmit_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 150, 100, 100, 100, "TRANSMIT");
	fl_set_object_color(obj, FL_DARKORANGE, FL_RED);
	fl_set_object_callback(obj, transmit_button_cb, 0);

fdui->threshold_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 350, 10, 30, 100, "threshold");
	fl_set_object_callback(obj, threshold_slider_cb, 0);
	fl_set_slider_precision(obj, 0);
	fl_set_slider_bounds(obj, 0, -100);
	fl_set_slider_value(obj, 50);

fdui->audio_peak_indicator_slider = obj =\
	fl_add_valslider(FL_VERT_FILL_SLIDER, 310, 10, 30, 100, "peak audio");
	fl_set_object_callback(obj, audio_peak_indicator_slider_cb, 0);
	fl_set_slider_precision(obj, 0);
	fl_set_slider_bounds(obj, 0, -100);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_slider_value(obj, 50);

fdui->on_time_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 20, 10, 30, 100, "on ms");
	fl_set_object_callback(obj, on_time_slider_cb, 0);
	fl_set_slider_precision(obj, 1);
	fl_set_slider_bounds(obj, 10, 1);
	fl_set_slider_value(obj, 1.5);

fdui->off_time_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 60, 10, 30, 100, "off ms");
	fl_set_object_callback(obj, off_time_slider_cb, 0);
	fl_set_slider_precision(obj, 0);
	fl_set_slider_bounds(obj, 4000, 100);
	fl_set_slider_value(obj, 1000);

fdui->transmission_lock_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 155, 240, 90, 40, "TX LOCK");
	fl_set_object_color(obj, FL_COL1, FL_BLUE);
	fl_set_object_callback(obj, transmission_lock_button_cb, 0);

fdui->sound_browser = obj =\
    fl_add_browser(FL_HOLD_BROWSER, 260, 130, 130, 70, "");
    fl_set_object_color(obj, FL_WHITE, 15);
    fl_set_object_callback(obj, sound_browser_cb, 0);
    fl_set_browser_dblclick_callback(obj, sound_browser_double_cb, 0);
    fl_set_object_dblbuffer(obj, 1);

fdui -> sound_browser_text = obj =\
	fl_add_text(FL_NORMAL_TEXT, 300, 200, 40, 20, "sounds");

fdui->play_sound_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 260, 210, 20, 20, "pla");
	fl_set_object_color(obj, FL_COL1, FL_BLUE);
	fl_set_object_callback(obj, play_sound_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui->stop_sound_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 260, 240, 20, 20, "sto");
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_callback(obj, stop_sound_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui->use_xpequ_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 290, 240, 20, 20, "xpq");
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_callback(obj, use_xpequ_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui->add_sound_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 340, 210, 20, 20, "add");
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_object_callback(obj, add_sound_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui->show_sounds_without_path_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 340, 240, 20, 20, "no\npath");
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_callback(obj, show_sounds_without_path_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui->in_sound_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 150, 210, 20, 20, "in");
	fl_set_object_color(obj, FL_COL1, FL_BLUE);
	fl_set_object_callback(obj, in_sound_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui->out_sound_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 230, 210, 20, 20, "out");
	fl_set_object_color(obj, FL_COL1, FL_BLUE);
	fl_set_object_callback(obj, out_sound_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui->delete_sound_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 370, 210, 20, 20, "del");
	fl_set_object_color(obj, FL_COL1, FL_RED);
	fl_set_object_callback(obj, delete_sound_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui->log_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 370, 240, 20, 20, "log");
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_callback(obj, log_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui -> audio_input_device_select_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 10, 125, 90, 30, "");
	fl_set_object_callback(obj, audio_input_device_select_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> audio_input_text = obj =\
	fl_add_text(FL_NORMAL_TEXT, 100, 130, 40, 20, "input");
//	fl_set_object_boxtype(obj,FL_DOWN_BOX);
//	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
//	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
//	fl_set_object_lcol(obj, FL_BLACK);
//	fl_set_object_color(obj, FL_SPRINGGREEN, FL_COL1);

fdui -> audio_output_device_select_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 10, 165, 90, 30, "");
	fl_set_object_callback(obj, audio_output_device_select_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> audio_output_text = obj =\
	fl_add_text(FL_NORMAL_TEXT, 100, 170, 40, 20, "output");

fdui->transmission_inhibit_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 10, 205, 90, 40, "INHIBIT");
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_callback(obj, transmission_inhibit_button_cb, 0);

fdui -> rts_state_indicator = obj =\
	fl_add_box(FL_DOWN_BOX, 110, 210, 20, 20, "RTS");
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM);	

fdui->exit_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 10, 260, 90, 30, "EXIT");
	fl_set_object_callback(obj, exit_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);

fl_add_signal_callback(\
    SIGALRM, (FL_SIGNAL_HANDLER)one_second_tick, NULL); //&mydata);
alarm(1);

fl_end_form();

fdui -> xpvox -> fdui = fdui;

return fdui;
} /* end function create_form_xpvox */



